Browse Source

Preparing app setup

Bob Mottram 8 years ago
parent
commit
03ff899399
3 changed files with 127 additions and 94 deletions
  1. 7
    76
      src/freedombone-selector
  2. 113
    0
      src/freedombone-utils-selector
  3. 7
    18
      src/freedombone-utils-setup

+ 7
- 76
src/freedombone-selector View File

@@ -42,56 +42,7 @@ source $PROJECT_INSTALL_DIR/${PROJECT_NAME}-vars
42 42
 
43 43
 COMPLETION_FILE=$HOME/${PROJECT_NAME}-completed.txt
44 44
 
45
-# Array containing names of available apps
46
-APPS_AVAILABLE=()
47
-
48
-# Array containing 1 or 0 indicating installed apps
49
-APPS_INSTALLED=()
50
-
51
-# Apps selected with checklist
52
-APPS_CHOSEN=()
53
-
54
-function item_in_array {
55
-	local e
56
-	for e in "${@:2}"; do [[ "$e" == "$1" ]] && return 0; done
57
-	return 1
58
-}
59
-
60
-function app_is_installed {
61
-	app_name="$1"
62
-	if [ ! -f $COMPLETION_FILE ]; then
63
-		echo "0"
64
-		return
65
-	fi
66
-
67
-	if ! grep -Fxq "install_${app_name}" $COMPLETION_FILE; then
68
-		echo "0"
69
-	else
70
-		echo "1"
71
-	fi
72
-}
73
-
74
-function get_apps_installed {
75
-	for a in "${APPS_AVAILABLE[@]}"
76
-	do
77
-		APPS_INSTALLED+=("$(app_is_installed $a)")
78
-	done
79
-}
80
-
81
-function detect_apps {
82
-	FILES=$PROJECT_INSTALL_DIR/${PROJECT_NAME}-app-*
83
-
84
-	# for all the app scripts
85
-	for filename in $FILES
86
-	do
87
-		app_name=$(echo "${filename}" | awk -F '-app-' '{print $2}')
88
-		if [[ $(item_in_array ${app_name} ${APPS_AVAILABLE[@]}) != 0 ]]; then
89
-			APPS_AVAILABLE+=("${app_name}")
90
-			APPS_CHOSEN+=("0")
91
-		fi
92
-	done
93
-	get_apps_installed
94
-}
45
+source $PROJECT_INSTALL_DIR/${PROJECT_NAME}-utils-selector
95 46
 
96 47
 function show_apps {
97 48
 	applist=""
@@ -124,7 +75,7 @@ function show_apps {
124 75
 	fi
125 76
 }
126 77
 
127
-function remove_apps {
78
+function remove_apps_interactive {
128 79
 	# which apps need to be removed?
129 80
 	removals=""
130 81
 	app_index=0
@@ -162,20 +113,10 @@ function remove_apps {
162 113
 
163 114
 	# remove the apps
164 115
 	read_configuration
165
-	for a in "${APPS_AVAILABLE[@]}"
166
-	do
167
-		if [[ ${APPS_INSTALLED[$app_index]} == "1" ]]; then
168
-			if [[ ${APPS_CHOSEN[$app_index]} == "0" ]]; then
169
-				echo $"Removing application: ${a}"
170
-				remove_${a}
171
-				echo $"${a} was removed"
172
-			fi
173
-		fi
174
-		app_index=$[app_index+1]
175
-	done
116
+	remove_apps
176 117
 }
177 118
 
178
-function install_apps {
119
+function install_apps_interactive {
179 120
 	# which apps need to be installed?
180 121
 	installs=""
181 122
 	app_index=0
@@ -213,17 +154,7 @@ function install_apps {
213 154
 
214 155
 	# install the apps
215 156
 	read_configuration
216
-	for a in "${APPS_AVAILABLE[@]}"
217
-	do
218
-		if [[ ${APPS_INSTALLED[$app_index]} == "0" ]]; then
219
-			if [[ ${APPS_CHOSEN[$app_index]} == "1" ]]; then
220
-				echo $"Installing application: ${a}"
221
-				install_${a}
222
-				echo $"${a} was installed"
223
-			fi
224
-		fi
225
-		app_index=$[app_index+1]
226
-	done
157
+	install_apps
227 158
 }
228 159
 
229 160
 ${PROJECT_NAME}-tests
@@ -242,7 +173,7 @@ show_apps
242 173
 
243 174
 clear
244 175
 
245
-remove_apps
246
-install_apps
176
+remove_apps_interactive
177
+install_apps_interactive
247 178
 
248 179
 exit 0

+ 113
- 0
src/freedombone-utils-selector View File

@@ -0,0 +1,113 @@
1
+#!/bin/bash
2
+#
3
+# .---.                  .              .
4
+# |                      |              |
5
+# |--- .--. .-.  .-.  .-.|  .-. .--.--. |.-.  .-. .--.  .-.
6
+# |    |   (.-' (.-' (   | (   )|  |  | |   )(   )|  | (.-'
7
+# '    '     --'  --'  -' -  -' '  '   -' -'   -' '   -  --'
8
+#
9
+#                    Freedom in the Cloud
10
+#
11
+# Functions for selecting which apps to install or remove
12
+#
13
+# License
14
+# =======
15
+#
16
+# Copyright (C) 2015-2016 Bob Mottram <bob@robotics.uk.to>
17
+#
18
+# This program is free software: you can redistribute it and/or modify
19
+# it under the terms of the GNU Affero General Public License as published by
20
+# the Free Software Foundation, either version 3 of the License, or
21
+# (at your option) any later version.
22
+#
23
+# This program is distributed in the hope that it will be useful,
24
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
25
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
26
+# GNU Affero General Public License for more details.
27
+#
28
+# You should have received a copy of the GNU Affero General Public License
29
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
30
+
31
+# Array containing names of available apps
32
+APPS_AVAILABLE=()
33
+
34
+# Array containing 1 or 0 indicating installed apps
35
+APPS_INSTALLED=()
36
+
37
+# Apps selected with checklist
38
+APPS_CHOSEN=()
39
+
40
+function item_in_array {
41
+	local e
42
+	for e in "${@:2}"; do [[ "$e" == "$1" ]] && return 0; done
43
+	return 1
44
+}
45
+
46
+function app_is_installed {
47
+	app_name="$1"
48
+	if [ ! -f $COMPLETION_FILE ]; then
49
+		echo "0"
50
+		return
51
+	fi
52
+
53
+	if ! grep -Fxq "install_${app_name}" $COMPLETION_FILE; then
54
+		echo "0"
55
+	else
56
+		echo "1"
57
+	fi
58
+}
59
+
60
+function get_apps_installed {
61
+	for a in "${APPS_AVAILABLE[@]}"
62
+	do
63
+		APPS_INSTALLED+=("$(app_is_installed $a)")
64
+	done
65
+}
66
+
67
+function detect_apps {
68
+	FILES=$PROJECT_INSTALL_DIR/${PROJECT_NAME}-app-*
69
+
70
+	APPS_AVAILABLE=()
71
+	APPS_CHOSEN=()
72
+
73
+	# for all the app scripts
74
+	for filename in $FILES
75
+	do
76
+		app_name=$(echo "${filename}" | awk -F '-app-' '{print $2}')
77
+		if [[ $(item_in_array ${app_name} ${APPS_AVAILABLE[@]}) != 0 ]]; then
78
+			APPS_AVAILABLE+=("${app_name}")
79
+			APPS_CHOSEN+=("0")
80
+		fi
81
+	done
82
+	get_apps_installed
83
+}
84
+
85
+function remove_apps {
86
+	app_index=0
87
+	for a in "${APPS_AVAILABLE[@]}"
88
+	do
89
+		if [[ ${APPS_INSTALLED[$app_index]} == "1" ]]; then
90
+			if [[ ${APPS_CHOSEN[$app_index]} == "0" ]]; then
91
+				echo $"Removing application: ${a}"
92
+				remove_${a}
93
+				echo $"${a} was removed"
94
+			fi
95
+		fi
96
+		app_index=$[app_index+1]
97
+	done
98
+}
99
+
100
+function install_apps {
101
+	app_index=0
102
+	for a in "${APPS_AVAILABLE[@]}"
103
+	do
104
+		if [[ ${APPS_INSTALLED[$app_index]} == "0" ]]; then
105
+			if [[ ${APPS_CHOSEN[$app_index]} == "1" ]]; then
106
+				echo $"Installing application: ${a}"
107
+				install_${a}
108
+				echo $"${a} was installed"
109
+			fi
110
+		fi
111
+		app_index=$[app_index+1]
112
+	done
113
+}

+ 7
- 18
src/freedombone-utils-setup View File

@@ -326,24 +326,13 @@ function setup_web {
326 326
 }
327 327
 
328 328
 function setup_apps {
329
-	install_zeronet
330
-	install_syncthing
331
-	install_gogs
332
-	install_xmpp
333
-	install_tox
334
-	install_irc
335
-	install_mumble
336
-	install_sip
337
-	install_wiki
338
-	install_blog
339
-	install_gnusocial
340
-	install_rss
341
-	install_hubzilla
342
-	#install_webmail
343
-	#install_search_engine
344
-	install_dlna
345
-	#install_mediagoblin
346
-	#install_ipfs
329
+	function_check detect_apps
330
+	detect_apps
331
+
332
+	# TODO choose apps based upon variants
333
+
334
+	function_check install_apps
335
+	install_apps
347 336
 }
348 337
 
349 338
 # NOTE: deliberately no exit 0